VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.1#0"; "COMCTL32.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form fEditor 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Map Editor"
   ClientHeight    =   7425
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7005
   Icon            =   "fEditor.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   7425
   ScaleWidth      =   7005
   StartUpPosition =   2  'Bildschirmmitte
   Begin ComctlLib.Toolbar tbrEditor 
      Align           =   1  'Oben ausrichten
      Height          =   420
      Left            =   0
      TabIndex        =   3
      Top             =   0
      Width           =   7005
      _ExtentX        =   12356
      _ExtentY        =   741
      ButtonWidth     =   635
      ButtonHeight    =   582
      Appearance      =   1
      ImageList       =   "imlDesigner"
      _Version        =   327680
      BeginProperty Buttons {0713E452-850A-101B-AFC0-4210102A8DA7} 
         NumButtons      =   7
         BeginProperty Button1 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Key             =   "NEW"
            Object.ToolTipText     =   "Create a new map"
            Object.Tag             =   ""
            ImageIndex      =   1
         EndProperty
         BeginProperty Button2 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Key             =   "OPEN"
            Object.ToolTipText     =   "Open an existing map"
            Object.Tag             =   ""
            ImageIndex      =   2
         EndProperty
         BeginProperty Button3 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Key             =   "SAVE"
            Object.ToolTipText     =   "Save the current map"
            Object.Tag             =   ""
            ImageIndex      =   3
         EndProperty
         BeginProperty Button4 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Key             =   ""
            Object.Tag             =   ""
            Style           =   3
            MixedState      =   -1  'True
         EndProperty
         BeginProperty Button5 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Key             =   "TOOLPAL"
            Object.ToolTipText     =   "Display tile palette"
            Object.Tag             =   ""
            ImageIndex      =   4
            Style           =   1
         EndProperty
         BeginProperty Button6 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Key             =   "TOOLPROP"
            Object.ToolTipText     =   "Display map propertys"
            Object.Tag             =   ""
            ImageIndex      =   5
            Style           =   1
         EndProperty
         BeginProperty Button7 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Key             =   "TOOLRADAR"
            Object.ToolTipText     =   "Display an overview"
            Object.Tag             =   ""
            ImageIndex      =   6
            Style           =   1
         EndProperty
      EndProperty
      MouseIcon       =   "fEditor.frx":0442
   End
   Begin VB.HScrollBar hscMap 
      Height          =   225
      LargeChange     =   5
      Left            =   0
      Max             =   29
      TabIndex        =   2
      Top             =   7185
      Width           =   6765
   End
   Begin VB.VScrollBar vscMap 
      Height          =   6765
      LargeChange     =   5
      Left            =   6780
      Max             =   29
      TabIndex        =   1
      Top             =   420
      Width           =   210
   End
   Begin VB.PictureBox picMap 
      BackColor       =   &H00000000&
      Height          =   6750
      Left            =   15
      ScaleHeight     =   446
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   446
      TabIndex        =   0
      Top             =   420
      Width           =   6750
   End
   Begin MSComDlg.CommonDialog cdgEditor 
      Left            =   75
      Top             =   570
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
   End
   Begin ComctlLib.ImageList imlDesigner 
      Left            =   0
      Top             =   1275
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   327680
      BeginProperty Images {0713E8C2-850A-101B-AFC0-4210102A8DA7} 
         NumListImages   =   6
         BeginProperty ListImage1 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fEditor.frx":045E
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fEditor.frx":0778
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fEditor.frx":0A92
            Key             =   ""
         EndProperty
         BeginProperty ListImage4 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fEditor.frx":0DAC
            Key             =   ""
         EndProperty
         BeginProperty ListImage5 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fEditor.frx":10C6
            Key             =   ""
         EndProperty
         BeginProperty ListImage6 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fEditor.frx":13E0
            Key             =   ""
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "fEditor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' On Form Activation, initialize main loop
Private Sub Form_Activate()

    If Not Program.Initialized Then
        ' Call main loop
        Call AppLoop
    End If
    
End Sub

' -------------------------------------------------------------
' Initialize Editor when form is loaded
Private Sub Form_Load()

    ' initialize app
    Call AppInit
    
End Sub

' -------------------------------------------------------------
' User changes form size: Resize all controls, redraw map
Private Sub Form_Resize()

    ' Resize controls within window to fit window extend ...
    Me.picMap.Width = IIf(Me.Width - 400 > 0, Me.Width - 400, 0)
    Me.picMap.Height = IIf(Me.Height - 1100 > 0, Me.Height - 1100, 0)
    Me.hscMap.Top = Me.picMap.Top + Me.picMap.Height + 20
    Me.hscMap.Width = Me.picMap.Width
    Me.vscMap.Left = Me.picMap.Left + Me.picMap.Width + 20
    Me.vscMap.Height = Me.picMap.Height
    
    ' Calcualte new map extent...
    
    Dim nNewExtentX As Integer, nNewExtentY As Integer      ' Store calculated new map extent
    
    ' Calculate new extent
    nNewExtentX = (fEditor.picMap.Width \ 10) \ TileSet.TileSize
    nNewExtentY = (fEditor.picMap.Height \ 10) \ TileSet.TileSize
    If nNewExtentX > Map.ExtentX Then nNewExtentX = Map.ExtentX
    If nNewExtentY > Map.ExtentY Then nNewExtentY = Map.ExtentY
    
    ' if new extent differs from current extent: Set new extent
    If nNewExtentX <> Map.DisplayExtentX Or nNewExtentY <> Map.DisplayExtentY Then
        Map.DisplayExtentX = nNewExtentX
        Map.DisplayExtentY = nNewExtentY
        Call DrawMap
        Call FillMapAnimationLookup
    End If
   
End Sub

' -------------------------------------------------------------
' Editor is terminated
Private Sub Form_Unload(Cancel As Integer)
    
    ' terminate main loop
    If Program.Running Then
        Program.Running = False
        Cancel = True
    End If
    
End Sub

' -------------------------------------------------------------
' Process mouseclick on map: Set tiles according to current settings and button pressed
Private Sub picMap_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Dim nCurX As Integer, nCurY As Integer  ' Variables for storing the current map position in squares
    Dim bSquareChanged As Boolean           ' variable to record changes in map
    Dim nNewTileIndex As Byte               ' Tile index for randomization
    
    ' Calculate tile clicked
    nCurX = (X \ TileSet.TileSize) + Map.CurrentX
    nCurY = (Y \ TileSet.TileSize) + Map.CurrentY

    ' Left button sets tile standard
    If Button = 1 Then
    
        ' Set map square to new tile index (! only if necessary)
        If Map.Squares(nCurX, nCurY).TileIndex <> SelectedTile.Index Then
            
            Map.Squares(nCurX, nCurY).TileIndex = SelectedTile.Index
        
            ' Redraw the map
            Call DrawSquare(nCurX - Map.CurrentX, nCurY - Map.CurrentY)
            
            ' Calculate animated tiles
            Call FillMapAnimationLookup
            
        End If
        
    End If
    
    ' Right button sets tile special
    If Button = 2 Then
                
        ' Random tile
        If SelectedTile.RandomSequence > -1 Then
            
             ' Set square to new index
             Map.Squares(nCurX, nCurY).TileIndex = RandomTile(SelectedTile.RandomSequence).TileIndex(Int(Rnd(1) * RandomTile(SelectedTile.RandomSequence).TileCount))
            
            ' Redraw the map
            Call DrawSquare(nCurX - Map.CurrentX, nCurY - Map.CurrentY)
            
            ' Calculate animated tiles
            Call FillMapAnimationLookup
        
        End If
         
         ' Bordered tile
        If SelectedTile.BorderSequence > -1 Then
            
            ' Set Tile Index
            Map.Squares(nCurX, nCurY).TileIndex = SelectedTile.Index
            
            ' Calculate borders
            Call SetBorders(nCurX, nCurY, SelectedTile.BorderSequence)
            
            ' Redraw the map (Whole map, one cannot be sure which tiles changed!)
            Call DrawMap
            
            ' Calculate animated tiles
            Call FillMapAnimationLookup
                
        End If
        
        ' Composite tile
        If SelectedTile.CompositeSequence > -1 Then
            
            Dim nRunX As Integer        ' Variable to run through composite tiles
            Dim nRunY As Integer        ' Variable to run through composite tiles
            Dim nTileIndex As Integer   ' Index of tile currently drawn within sequence
            
            ' Step trough all tiles making up composite tile, set map accordingly
            nTileIndex = 0
            For nRunY = 0 To CompositeTile(SelectedTile.CompositeSequence).SizeY - 1
                For nRunX = 0 To CompositeTile(SelectedTile.CompositeSequence).SizeX - 1
                    If nRunX + nCurX <= Map.ExtentX And nRunY + nCurX < Map.ExtentY Then
                        Map.Squares(nCurX + nRunX, nCurY + nRunY).TileIndex = CompositeTile(SelectedTile.CompositeSequence).TileIndex(nTileIndex)
                        nTileIndex = nTileIndex + 1
                    End If
                Next
            Next
            
            ' Redraw the map
            Call DrawMap
            
            ' Calculate animated tiles
            Call FillMapAnimationLookup
            
        End If

    End If
    
End Sub

' -------------------------------------------------------------
' Process map mousemove: same as mouseclick, so the user may drag to create tiles
Private Sub picMap_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Call picMap_MouseDown(Button, Shift, X, Y)

End Sub

' -------------------------------------------------------------
' Process Toolbar click
Private Sub tbrEditor_ButtonClick(ByVal Button As ComctlLib.Button)

    ' process user input via toolbar ...
    Select Case Button.Key
    
        ' Display/Hide property tool window
        Case "TOOLPROP"
            If Button.Value = tbrPressed Then
                fToolProps.Show
                SetWindowPos fToolProps.hwnd, -1, 0, 0, 0, 0, 83
            Else
                fToolProps.Hide
            End If
        
        ' Display/Hide tile palette tool window
        Case "TOOLPAL"
            If Button.Value = tbrPressed Then
                fToolTIles.Show
                SetWindowPos fToolTIles.hwnd, -1, 0, 0, 0, 0, 83
                fToolTIles.Refresh
                Call DrawTilePanel
            Else
                fToolTIles.Hide
            End If
        
        ' Display/Hide radar window
        Case "TOOLRADAR"
            If Button.Value = tbrPressed Then
                fToolRadar.Show 1
            End If
        
        ' Clear Map
        Case "NEW"
            Call ClearMap
        
        ' Open Map
        Case "OPEN"
            Call OpenMap
            
        ' Save Map
        Case "SAVE"
            Call SaveMap
            
    End Select
    
End Sub

' -------------------------------------------------------------
' User changes Y position of map

Private Sub vscMap_Change()

    ' Set new position
    Map.CurrentY = Me.vscMap.Value
    
    ' Redraw the map
    Call DrawMap
    Call FillMapAnimationLookup
    
End Sub

' -------------------------------------------------------------
' User changes X position of map
Private Sub hscMap_Change()

    ' Set new position
    Map.CurrentX = Me.hscMap.Value
    
    ' Redraw the map
    Call DrawMap
    Call FillMapAnimationLookup
    
End Sub

