VERSION 5.00
Begin VB.Form fToolTiles 
   BorderStyle     =   4  'Festes Werkzeugfenster
   Caption         =   "Tile Palette"
   ClientHeight    =   4920
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   1545
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4920
   ScaleWidth      =   1545
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.VScrollBar vscTile 
      Height          =   4860
      Left            =   1290
      TabIndex        =   5
      Top             =   30
      Width           =   240
   End
   Begin VB.PictureBox picTile 
      BackColor       =   &H00000000&
      Height          =   960
      Index           =   0
      Left            =   270
      ScaleHeight     =   900
      ScaleWidth      =   900
      TabIndex        =   4
      Top             =   30
      Width           =   960
   End
   Begin VB.PictureBox picTile 
      BackColor       =   &H00000000&
      Height          =   960
      Index           =   1
      Left            =   270
      ScaleHeight     =   900
      ScaleWidth      =   900
      TabIndex        =   3
      Top             =   1005
      Width           =   960
   End
   Begin VB.PictureBox picTile 
      BackColor       =   &H00000000&
      Height          =   960
      Index           =   2
      Left            =   270
      ScaleHeight     =   900
      ScaleWidth      =   900
      TabIndex        =   2
      Top             =   1980
      Width           =   960
   End
   Begin VB.PictureBox picTile 
      BackColor       =   &H00000000&
      Height          =   960
      Index           =   3
      Left            =   270
      ScaleHeight     =   900
      ScaleWidth      =   900
      TabIndex        =   1
      Top             =   2955
      Width           =   960
   End
   Begin VB.PictureBox picTile 
      BackColor       =   &H00000000&
      Height          =   960
      Index           =   4
      Left            =   270
      ScaleHeight     =   900
      ScaleWidth      =   900
      TabIndex        =   0
      Top             =   3930
      Width           =   960
   End
   Begin VB.Label lblFunction 
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "A"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   945
      Index           =   4
      Left            =   30
      TabIndex        =   10
      Top             =   3945
      Width           =   225
   End
   Begin VB.Label lblFunction 
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "A"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   960
      Index           =   3
      Left            =   30
      TabIndex        =   9
      Top             =   2955
      Width           =   225
   End
   Begin VB.Label lblFunction 
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "A"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   960
      Index           =   2
      Left            =   30
      TabIndex        =   8
      Top             =   1980
      Width           =   225
   End
   Begin VB.Label lblFunction 
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "A"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   960
      Index           =   1
      Left            =   30
      TabIndex        =   7
      Top             =   1005
      Width           =   225
   End
   Begin VB.Label lblFunction 
      BackColor       =   &H000000FF&
      BorderStyle     =   1  'Fest Einfach
      Caption         =   "A"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   960
      Index           =   0
      Left            =   30
      TabIndex        =   6
      Top             =   30
      Width           =   225
   End
End
Attribute VB_Name = "fToolTIles"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' -------------------------------------------------------------
' Formpaint: Redraw
Private Sub Form_Paint()

    ' Redraw display
    Call DrawTilePanel
        
End Sub

' -------------------------------------------------------------
' User closes tool form: Reset button in toolbar of main window
Private Sub Form_Unload(Cancel As Integer)

    ' Reset "show" button in main toolbar
    fEditor.tbrEditor.Buttons("TOOLPAL").Value = tbrUnpressed

End Sub

' -------------------------------------------------------------
' User selects a tile: Store tile settings in public variables for easy access throughout the app
Private Sub picTile_Click(Index As Integer)

    Dim nRunFrames As Integer   ' Variable to run through all frames displaying the visible tiles
    Dim nRunTiles As Integer    ' Variable to check for tiles in sequences
    Dim nRunSequence As Integer ' Variable to check sequences
    
    ' Set frame color to mark the tile currently selected
    For nRunFrames = 0 To 4
        Me.lblFunction(nRunFrames).BackColor = IIf(Index = nRunFrames, &HFF&, &H8000000F)
    Next
    
    ' Store selected tile index and sequence data ...
    
    SelectedTile.Index = Me.vscTile.Value + Index
    SelectedTile.BorderSequence = GetTileBorderSequence(SelectedTile.Index)
    SelectedTile.RandomSequence = GetTileRandomSequence(SelectedTile.Index)
    SelectedTile.CompositeSequence = GetTileCompositeSequence(SelectedTile.Index)
        
End Sub

' -------------------------------------------------------------
' User scrolls through tile list: Change tile settings accordingly
Private Sub vscTile_Change()

    Dim nRunFrames As Integer   ' Variable to run through all frames displaying the visible tiles
    
    ' Find out tile currently selected by looking for frame color
    For nRunFrames = 0 To 4
        If Me.lblFunction(nRunFrames).BackColor = &HFF& Then Exit For
    Next
    
    ' Call Tile Click routine (Scrolling in the panel equals the click on a new tile)
    Call picTile_Click(nRunFrames)
    
    ' Refresh display
    Call DrawTilePanel

End Sub

