VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.1#0"; "COMCTL32.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form fEditor 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Tileset Editor"
   ClientHeight    =   7425
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7005
   Icon            =   "fEditor.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   7425
   ScaleWidth      =   7005
   StartUpPosition =   2  'Bildschirmmitte
   Begin ComctlLib.Toolbar tbrEditor 
      Align           =   1  'Oben ausrichten
      Height          =   420
      Left            =   0
      TabIndex        =   3
      Top             =   0
      Width           =   7005
      _ExtentX        =   12356
      _ExtentY        =   741
      ButtonWidth     =   635
      ButtonHeight    =   582
      Appearance      =   1
      ImageList       =   "imlDesigner"
      _Version        =   327680
      BeginProperty Buttons {0713E452-850A-101B-AFC0-4210102A8DA7} 
         NumButtons      =   3
         BeginProperty Button1 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Key             =   "NEW"
            Object.ToolTipText     =   "Create a new tileset"
            Object.Tag             =   ""
            ImageIndex      =   1
         EndProperty
         BeginProperty Button2 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Key             =   "OPEN"
            Object.ToolTipText     =   "Open an existing tileset"
            Object.Tag             =   ""
            ImageIndex      =   2
         EndProperty
         BeginProperty Button3 {0713F354-850A-101B-AFC0-4210102A8DA7} 
            Key             =   "SAVE"
            Object.ToolTipText     =   "Save the current tileset"
            Object.Tag             =   ""
            ImageIndex      =   3
         EndProperty
      EndProperty
      MouseIcon       =   "fEditor.frx":0442
   End
   Begin VB.HScrollBar hscImage 
      Height          =   225
      LargeChange     =   5
      Left            =   0
      Max             =   29
      TabIndex        =   2
      Top             =   7185
      Width           =   6765
   End
   Begin VB.VScrollBar vscImage 
      Height          =   6765
      LargeChange     =   5
      Left            =   6780
      Max             =   29
      TabIndex        =   1
      Top             =   420
      Width           =   210
   End
   Begin VB.PictureBox picImage 
      BackColor       =   &H00000000&
      Height          =   6750
      Left            =   15
      ScaleHeight     =   446
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   446
      TabIndex        =   0
      Top             =   420
      Width           =   6750
   End
   Begin MSComDlg.CommonDialog cdgEditor 
      Left            =   75
      Top             =   570
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
   End
   Begin ComctlLib.ImageList imlDesigner 
      Left            =   0
      Top             =   1275
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   327680
      BeginProperty Images {0713E8C2-850A-101B-AFC0-4210102A8DA7} 
         NumListImages   =   6
         BeginProperty ListImage1 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fEditor.frx":045E
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fEditor.frx":0778
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fEditor.frx":0A92
            Key             =   ""
         EndProperty
         BeginProperty ListImage4 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fEditor.frx":0DAC
            Key             =   ""
         EndProperty
         BeginProperty ListImage5 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fEditor.frx":10C6
            Key             =   ""
         EndProperty
         BeginProperty ListImage6 {0713E8C3-850A-101B-AFC0-4210102A8DA7} 
            Picture         =   "fEditor.frx":13E0
            Key             =   ""
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "fEditor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' On Form Activation, initialize main loop
Private Sub Form_Activate()

    If Not Program.Initialized Then
        ' Call main loop
        Call AppLoop
    End If
    
End Sub

' -------------------------------------------------------------
' Initialize Editor when form is loaded
Private Sub Form_Load()

    ' initialize app
    Call AppInit
    
End Sub

' -------------------------------------------------------------
' User changes form size: Resize all controls, redraw map
Private Sub Form_Resize()

    ' Resize controls within window to fit window extend ...
    Me.picImage.Width = IIf(Me.Width - 400 > 0, Me.Width - 400, 0)
    Me.picImage.Height = IIf(Me.Height - 1100 > 0, Me.Height - 1100, 0)
    Me.hscImage.Top = Me.picImage.Top + Me.picImage.Height + 20
    Me.hscImage.Width = Me.picImage.Width
    Me.vscImage.Left = Me.picImage.Left + Me.picImage.Width + 20
    Me.vscImage.Height = Me.picImage.Height
  
End Sub

' -------------------------------------------------------------
' Editor is terminated
Private Sub Form_Unload(Cancel As Integer)
    
    ' terminate main loop
    If Program.Running Then
        Program.Running = False
        Cancel = True
    End If
    
End Sub

' -------------------------------------------------------------
' Process mouseclick on tileset image
Private Sub picMap_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    
    
End Sub

' -------------------------------------------------------------
' Process map mousemove: same as mouseclick, so the user may drag to create tiles
Private Sub picMap_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Call picMap_MouseDown(Button, Shift, X, Y)

End Sub

' -------------------------------------------------------------
' Process Toolbar click
Private Sub tbrEditor_ButtonClick(ByVal Button As ComctlLib.Button)

    ' process user input via toolbar ...
    Select Case Button.Key
        
        ' Clear Tileset
        Case "NEW"
        
        ' Open Tileset
        Case "OPEN"

        ' Save Tileset
        Case "SAVE"
            
    End Select
    
End Sub

' -------------------------------------------------------------
' User changes Y position of tileset image

Private Sub vscMap_Change()

    
End Sub

' -------------------------------------------------------------
' User changes X position of tileset image
Private Sub hscMap_Change()

   
End Sub

