VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cAniSquares"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Collection" ,"cAniSquare"
Attribute VB_Ext_KEY = "Member0" ,"cAniSquare"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

' CLASS LOCAL DECLARATIONS ...

Private Type tAniSquare
    PositionH As Integer
    PositionV As Integer
End Type

Private Local_Anisquare(99) As tAniSquare
Private Local_AnisquareCount As Integer

' CLASS PROPERTYS

' CLASS FUNCTIONS AND PROCEDURES...

' Add an anisquare to the collection
Public Sub Add(nPositionH As Integer, nPositionV As Integer)
    
    Dim bCreateNew As Boolean       ' Flag enabling creation
    Dim nRunAniSquares As Integer   ' Variable to run through existing anisquares
    
    ' Check for existance of provided square in animation lookup list
    bCreateNew = True
    For nRunAniSquares = 0 To Local_AnisquareCount - 1
        If Local_Anisquare(nRunAniSquares).PositionH = nPositionH Then
            If Local_Anisquare(nRunAniSquares).PositionV = nPositionV Then
                bCreateNew = False
                Exit For
            End If
        End If
    Next
    
    ' Create only if not existing
    If bCreateNew Then
    
        ' Set values of new member
        Local_Anisquare(Local_AnisquareCount).PositionH = nPositionH
        Local_Anisquare(Local_AnisquareCount).PositionV = nPositionV
        Local_AnisquareCount = Local_AnisquareCount + 1
        
    End If
    
End Sub

Friend Property Get Item(nIndex As Integer) As tAniSquare
Attribute Item.VB_UserMemId = 0
      Item.PositionH = Local_Anisquare(nIndex).PositionH
      Item.PositionV = Local_Anisquare(nIndex).PositionV
End Property

' Number of items
Public Property Get Count() As Long
    Count = Local_AnisquareCount
End Property

' Clear all anisquares
Public Sub Clear()
    Local_AnisquareCount = 0
End Sub
