VERSION 5.00
Begin VB.Form fSample 
   BackColor       =   &H00000000&
   BorderStyle     =   0  'Kein
   Caption         =   "DirectAction Tester"
   ClientHeight    =   6990
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   9825
   Icon            =   "fSample.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   ScaleHeight     =   466
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   655
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'Bildschirmmitte
   WindowState     =   2  'Maximiert
End
Attribute VB_Name = "fSample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Activate()

    ' On initialization complete
    If Not Program.Running Then
    
        ' Start main application loop ...
        Call AppLoop
        
    End If
    
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

    Dim nH As Long, nV As Long      ' Variables to retrieve current position of main display
   
    ' Stop on ESC key
    If KeyCode = vbKeyEscape Then
        ' Terminate main loop
        Program.Running = False
    End If
    
    ' Set camera1 on 1 key
    If KeyCode = vbKey1 Then
        
        ' Set position retrieval mode to units (1/10 pixel)
        MyEngine.Displays.Item("VIDEO1").ScaleMode = dxsSMUnit
        
        ' Retrieve current position of main display
        nH = MyEngine.Displays.Item("MAIN").CurrentLeft
        nV = MyEngine.Displays.Item("MAIN").CurrentTop
        
        ' Set position of video display
        MyEngine.Displays.Item("VIDEO1").Scroll nH, nV, dxsAbsolute
        
    End If
    
    ' Set camera2 on 2 key
    If KeyCode = vbKey2 Then
    
        ' Set position retrieval mode to units (1/10 pixel)
        MyEngine.Displays.Item("VIDEO2").ScaleMode = dxsSMUnit
        
        ' Retrieve current position of main display
        nH = MyEngine.Displays.Item("MAIN").CurrentLeft
        nV = MyEngine.Displays.Item("MAIN").CurrentTop
        
        ' Set position of video display
        MyEngine.Displays.Item("VIDEO2").Scroll nH, nV, dxsAbsolute
        
    End If
    
    ' Set radar on R key
    If KeyCode = vbKeyR Then
    
        ' Set position retrieval mode to units (1/10 pixel)
        MyEngine.Displays.Item("OVERVIEW").ScaleMode = dxsSMUnit
        
        ' Retrieve current position of main display
        nH = MyEngine.Displays.Item("MAIN").CurrentLeft
        nV = MyEngine.Displays.Item("MAIN").CurrentTop
        
        ' Set position of video display
        MyEngine.Displays.Item("OVERVIEW").Scroll nH, nV, dxsAbsolute
        
    End If
    
    
    ' Increase scrolling speed on + key
    If KeyCode = vbKeyAdd And Program.ScrollSpeed < 160 Then
        Program.ScrollSpeed = Program.ScrollSpeed * 2
    End If
    
    ' Decrease scrolling speed on - key
    If KeyCode = vbKeySubtract And Program.ScrollSpeed > 5 Then
        Program.ScrollSpeed = Program.ScrollSpeed \ 2
    End If
    
End Sub

Private Sub Form_Load()

    ' On Program startup ...
    If Program.Initialized = False Then
        
        ' Initialize - Application specific
        Call AppInit
        
    End If
    
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)

    ' Remember last mouse coordinates
    Program.MouseX = X
    Program.MouseY = Y
    
End Sub

