VERSION 5.00
Begin VB.Form fToolProps 
   BorderStyle     =   4  'Festes Werkzeugfenster
   Caption         =   "Map Propertys"
   ClientHeight    =   1740
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   2670
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1740
   ScaleWidth      =   2670
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton btnCancel 
      Caption         =   "&Cancel"
      Height          =   360
      Left            =   45
      TabIndex        =   7
      Top             =   1350
      Width           =   1245
   End
   Begin VB.ComboBox kmbTileSet 
      Height          =   315
      Left            =   1050
      TabIndex        =   6
      Text            =   "Combo1"
      Top             =   540
      Width           =   1545
   End
   Begin VB.ComboBox kmbSizeY 
      BackColor       =   &H00FFFFFF&
      Height          =   315
      ItemData        =   "fToolProps.frx":0000
      Left            =   1890
      List            =   "fToolProps.frx":002B
      Style           =   2  'Dropdown-Liste
      TabIndex        =   4
      Top             =   75
      Width           =   705
   End
   Begin VB.ComboBox kmbSizeX 
      BackColor       =   &H00FFFFFF&
      Height          =   315
      ItemData        =   "fToolProps.frx":0069
      Left            =   1050
      List            =   "fToolProps.frx":0094
      Style           =   2  'Dropdown-Liste
      TabIndex        =   2
      Top             =   75
      Width           =   705
   End
   Begin VB.CommandButton btnApply 
      Caption         =   "&Apply"
      Enabled         =   0   'False
      Height          =   360
      Left            =   1395
      TabIndex        =   0
      Top             =   1350
      Width           =   1245
   End
   Begin VB.Label lbl 
      Caption         =   "Tileset name"
      Height          =   255
      Index           =   2
      Left            =   60
      TabIndex        =   5
      Top             =   615
      Width           =   960
   End
   Begin VB.Label lbl 
      Caption         =   "x"
      Height          =   240
      Index           =   1
      Left            =   1770
      TabIndex        =   3
      Top             =   120
      Width           =   90
   End
   Begin VB.Label lbl 
      Caption         =   "Map size"
      Height          =   255
      Index           =   0
      Left            =   90
      TabIndex        =   1
      Top             =   180
      Width           =   735
   End
End
Attribute VB_Name = "fToolProps"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' -------------------------------------------------------------
' Apply changes: Set Map Size, change tileset
Private Sub btnApply_Click()

    ' Change map size
    If Val(Me.kmbSizeX.List(Me.kmbSizeX.ListIndex)) - 1 <> Map.ExtentX Or Val(Me.kmbSizeY.List(Me.kmbSizeY.ListIndex)) - 1 <> Map.ExtentY Then
        ' Query before erasing
        If MsgBox("Changing the map size will dump the current map. Proceed?", vbYesNo + vbQuestion + vbSystemModal, "Map Editor") = vbYes Then
            Call ChangeMapSize(Val(Me.kmbSizeX.List(Me.kmbSizeX.ListIndex)) - 1, Val(Me.kmbSizeY.List(Me.kmbSizeY.ListIndex)) - 1)
        Else
            Call Form_Load
        End If
    End If
    
    ' Load new Tileset
    If Me.kmbTileSet.List(Me.kmbTileSet.ListIndex) <> TileSet.FileName Then
        Call LoadTileset(Me.kmbTileSet.List(Me.kmbTileSet.ListIndex))
    End If
    
    ' Refresh display(s)
    Call DrawMap
    Call FillMapAnimationLookup
    
    ' Reset button states
    Me.btnCancel.SetFocus
    Me.btnApply.Enabled = False
    
End Sub

Private Sub btnCancel_Click()

    ' Restore original values
    Call Form_Load
    
End Sub

' -------------------------------------------------------------
' Form load: Refill tileset list, Reset Size lists
Private Sub Form_Load()

    Dim sFile As String             ' Variable holding file to be checked
    Dim bBitmapFound As Boolean     ' Variable for checking for bitmap
    Dim nRunCombo As Integer        ' Variable to run throuh all entrys of a combo
    
    ' Reset map size lists ...
   
    ' Set X Size
    For nRunCombo = 0 To Me.kmbSizeX.ListCount - 1
        If Val(Me.kmbSizeX.List(nRunCombo)) = Map.ExtentX + 1 Then
            Me.kmbSizeX.ListIndex = nRunCombo
            Exit For
        End If
    Next
    
    ' Set Y Size
    For nRunCombo = 0 To Me.kmbSizeY.ListCount - 1
        If Val(Me.kmbSizeY.List(nRunCombo)) = Map.ExtentY + 1 Then
            Me.kmbSizeY.ListIndex = nRunCombo
            Exit For
        End If
    Next
        
    ' Input Tileset list ...
    
    ' Read first file found
    sFile = Dir(App.Path + "\*.DEF")
    
    ' Loop through all files available
    Do While sFile <> ""
    
        ' Check for bitmap existance (A Tileset consists of .DEF and .BMP !)
        On Error GoTo CheckForBitmap
        bBitmapFound = False
        Open App.Path + Left(sFile, Len(sFile) - 3) + ".BMP" For Input As #1
        Close #1
        On Error GoTo 0
        bBitmapFound = True
CheckForBitmap:

        ' Insert into kombo list
        Me.kmbTileSet.AddItem Left(sFile, Len(sFile) - 4)
        
        ' Get next tileset
        sFile = Dir
        
    Loop
    
    ' Select current tileset
    
    For nRunCombo = 0 To Me.kmbTileSet.ListCount - 1
        If Me.kmbTileSet.List(nRunCombo) = TileSet.FileName Then
            Me.kmbTileSet.ListIndex = nRunCombo
            Exit For
        End If
    Next
    
    ' Disable apply button
    Me.btnApply.Enabled = False
    
End Sub
' -------------------------------------------------------------
' User closes tool form: Reset button in toolbar of main window
Private Sub Form_Unload(Cancel As Integer)

    ' Reset "show" button in main toolbar
    fEditor.tbrEditor.Buttons("TOOLPROP").Value = tbrUnpressed
    
End Sub

' -------------------------------------------------------------
' User Changes any property: Enable APPLY button

Private Sub kmbSizeX_Click()

    Me.btnApply.Enabled = True
    
End Sub

Private Sub kmbSizeY_Click()

    Me.btnApply.Enabled = True

End Sub

Private Sub kmbTileSet_Click()

    Me.btnApply.Enabled = True
    
End Sub

