VERSION 5.00
Begin VB.Form fToolRadar 
   BorderStyle     =   4  'Festes Werkzeugfenster
   Caption         =   "Radar View"
   ClientHeight    =   3150
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   3135
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   210
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   209
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Timer tmrRadar 
      Interval        =   10
      Left            =   -15
      Top             =   -15
   End
   Begin VB.PictureBox picRadar 
      BackColor       =   &H00000000&
      Height          =   3075
      Left            =   30
      ScaleHeight     =   201
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   201
      TabIndex        =   0
      Top             =   30
      Width           =   3075
   End
End
Attribute VB_Name = "fToolRadar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' -----------------------------------------------------------------
' Set form topmost
Private Sub Form_Activate()

    SetWindowPos fToolRadar.hWnd, -1, 0, 0, 0, 0, 83
    
End Sub

' -----------------------------------------------------------------
' Reset main toolbar when unloading window
Private Sub Form_Unload(Cancel As Integer)
    
    fEditor.tbrEditor.Buttons("TOOLRADAR").Value = tbrUnpressed
    
End Sub

' -----------------------------------------------------------------
' Goto new map position when user clicks on radar map
Private Sub picRadar_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    Dim nNewPosX As Integer, nNewPosY As Integer  ' Variables to hold new map position
    
    ' Get clicked position
    nNewPosX = X - 3
    nNewPosY = Y - 3
    
    If NewPosX > -1 And nNewPosY > -1 Then
    
        ' Do not allow movement out of map extend
        If nNewPosX > Map.ExtentX - Map.DisplayExtentX Then nNewPosX = Map.ExtentX - Map.DisplayExtentX
        If nNewPosY > Map.ExtentY - Map.DisplayExtentY Then nNewPosY = Map.ExtentY - Map.DisplayExtentY
        
        'Set new position
        fEditor.hscMap.Value = nNewPosX
        fEditor.vscMap.Value = nNewPosY
        
        ' Exit radar window
        Unload Me
        
    End If
    
End Sub
' -----------------------------------------------------------------
' Draw radar map
Private Sub tmrRadar_Timer()

    Call DrawRadar
    Me.tmrRadar.Enabled = False
    
End Sub
